///////////////////////////////////////////////////////////
//  EntityChangeEvent.cs
//  Implementation of the Class EntityChangeEvent
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:55
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.CallbackData;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.CallbackData {
	/// <summary>
	/// A creation, modification or deletion event of an entity
	/// </summary>
	public class EntityChangeEvent {

		private Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind kind;
		private IEnumerable<Org.OMG.TACSIT.DataPayload.CallbackData.TEXAttribute> updatedAttributes;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload updatedEntity;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef deleted;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public EntityChangeEvent(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public EntityChangeEvent(Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind the_kind, IEnumerable<Org.OMG.TACSIT.DataPayload.CallbackData.TEXAttribute> the_updatedAttributes, Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload the_updatedEntity, Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef the_deleted){
			kind = the_kind;
			updatedAttributes = the_updatedAttributes;
			updatedEntity = the_updatedEntity;
			deleted = the_deleted;
		}

		/// <summary>
		/// Constructor with parameters for each mandatory property
		/// </summary>
		public EntityChangeEvent(Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind the_kind, Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload the_updatedEntity, Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef the_deleted){
			kind = the_kind;
			updatedEntity = the_updatedEntity;
			deleted = the_deleted;
		}

		~EntityChangeEvent(){

		}

		/// <summary>
		/// The operation performed by the event.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind Kind{
			get{
				return kind;
			}
			set{
				kind = value;
			}
		}

		/// <summary>
		/// Liste of the attributes that changed (when changeKind is UPDATE).
		/// </summary>
		public IEnumerable<Org.OMG.TACSIT.DataPayload.CallbackData.TEXAttribute> UpdatedAttributes{
			get{
				return updatedAttributes;
			}
			set{
				updatedAttributes = value;
			}
		}

		/// <summary>
		/// The created or modified entity.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload UpdatedEntity{
			get{
				return updatedEntity;
			}
			set{
				updatedEntity = value;
			}
		}

		/// <summary>
		/// Determine whether EntityChangeEvent has a valid updatedEntity property.
		/// </summary>
		public bool UpdatedEntityExists(){

			return (updatedEntity != null);
		}

		/// <summary>
		/// The deleted entity.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef Deleted{
			get{
				return deleted;
			}
			set{
				deleted = value;
			}
		}

		/// <summary>
		/// Determine whether EntityChangeEvent has a valid deleted property.
		/// </summary>
		public bool DeletedExists(){

			return (deleted != null);
		}

	}//end EntityChangeEvent

}//end namespace CallbackData