///////////////////////////////////////////////////////////
//  EntityChangeSinkEvent.cs
//  Implementation of the Class EntityChangeSinkEvent
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:55
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.EntityPayloadManagement;
using Org.OMG.TACSIT.DataPayload.CallbackData;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.CallbackData {
	/// <summary>
	/// An event of creations, modifications or deletions of entities used in DataSink.
	/// 
	/// </summary>
	public class EntityChangeSinkEvent {

		private Org.OMG.TACSIT.DataPayload.EntityPayloadManagement.EntityPayloadChunk updatedEntity;
		private Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind kind;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef deleted;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public EntityChangeSinkEvent(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public EntityChangeSinkEvent(Org.OMG.TACSIT.DataPayload.EntityPayloadManagement.EntityPayloadChunk the_updatedEntity, Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind the_kind, Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef the_deleted){
			updatedEntity = the_updatedEntity;
			kind = the_kind;
			deleted = the_deleted;
		}

		~EntityChangeSinkEvent(){

		}

		/// <summary>
		/// The created or modified entity.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayloadManagement.EntityPayloadChunk UpdatedEntity{
			get{
				return updatedEntity;
			}
			set{
				updatedEntity = value;
			}
		}

		/// <summary>
		/// Determine whether EntityChangeSinkEvent has a valid updatedEntity property.
		/// </summary>
		public bool UpdatedEntityExists(){

			return (updatedEntity != null);
		}

		/// <summary>
		/// The operation performed by the event.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind Kind{
			get{
				return kind;
			}
			set{
				kind = value;
			}
		}

		/// <summary>
		/// The deleted entity.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef Deleted{
			get{
				return deleted;
			}
			set{
				deleted = value;
			}
		}

		/// <summary>
		/// Determine whether EntityChangeSinkEvent has a valid deleted property.
		/// </summary>
		public bool DeletedExists(){

			return (deleted != null);
		}

	}//end EntityChangeSinkEvent

}//end namespace CallbackData