///////////////////////////////////////////////////////////
//  GroupChangeSinkEvent.cs
//  Implementation of the Class GroupChangeSinkEvent
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:56
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.CallbackData;
using Org.OMG.TACSIT.DataPayload.GroupPayload;
namespace Org.OMG.TACSIT.DataPayload.CallbackData {
	/// <summary>
	/// A creation, modification or deletion event of a group. Group modification
	/// events include adding and removing entities as well as adding and removing
	/// entity relationships.
	/// </summary>
	public class GroupChangeSinkEvent {

		private Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind kind;
		private Org.OMG.TACSIT.DataPayload.GroupPayload.GroupRef deleted;
		private Org.OMG.TACSIT.DataPayload.GroupPayload.GroupPayload updatedGroup;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public GroupChangeSinkEvent(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public GroupChangeSinkEvent(Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind the_kind, Org.OMG.TACSIT.DataPayload.GroupPayload.GroupRef the_deleted, Org.OMG.TACSIT.DataPayload.GroupPayload.GroupPayload the_updatedGroup){
			kind = the_kind;
			deleted = the_deleted;
			updatedGroup = the_updatedGroup;
		}

		~GroupChangeSinkEvent(){

		}

		/// <summary>
		/// The operation performed by the event.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind Kind{
			get{
				return kind;
			}
			set{
				kind = value;
			}
		}

		/// <summary>
		/// The deleted group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.GroupPayload.GroupRef Deleted{
			get{
				return deleted;
			}
			set{
				deleted = value;
			}
		}

		/// <summary>
		/// Determine whether GroupChangeSinkEvent has a valid deleted property.
		/// </summary>
		public bool DeletedExists(){

			return (deleted != null);
		}

		/// <summary>
		/// The created or modified group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.GroupPayload.GroupPayload UpdatedGroup{
			get{
				return updatedGroup;
			}
			set{
				updatedGroup = value;
			}
		}

		/// <summary>
		/// Determine whether GroupChangeSinkEvent has a valid updatedGroup property.
		/// </summary>
		public bool UpdatedGroupExists(){

			return (updatedGroup != null);
		}

	}//end GroupChangeSinkEvent

}//end namespace CallbackData