///////////////////////////////////////////////////////////
//  HistoryChangeEvent.cs
//  Implementation of the Class HistoryChangeEvent
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:56
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.CallbackData;
using Org.OMG.TACSIT.DataPayload.EntityHistory;
namespace Org.OMG.TACSIT.DataPayload.CallbackData {
	/// <summary>
	/// An event of creations, modifications or deletions of histories.
	/// </summary>
	public class HistoryChangeEvent {

		private DateTime timeOfDeleted;
		private Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind kind;
		private Org.OMG.TACSIT.DataPayload.EntityHistory.EntityHistoryPayload updatedHistory;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public HistoryChangeEvent(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public HistoryChangeEvent(DateTime the_timeOfDeleted, Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind the_kind, Org.OMG.TACSIT.DataPayload.EntityHistory.EntityHistoryPayload the_updatedHistory){
			timeOfDeleted = the_timeOfDeleted;
			kind = the_kind;
			updatedHistory = the_updatedHistory;
		}

		~HistoryChangeEvent(){

		}

		/// <summary>
		/// The time of the deleted history if this event is a deletion event.
		/// </summary>
		public DateTime TimeOfDeleted{
			get{
				return timeOfDeleted;
			}
			set{
				timeOfDeleted = value;
			}
		}

		/// <summary>
		/// The operation performed by the event.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.CallbackData.ChangeKind Kind{
			get{
				return kind;
			}
			set{
				kind = value;
			}
		}

		/// <summary>
		/// The created or modified history.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityHistory.EntityHistoryPayload UpdatedHistory{
			get{
				return updatedHistory;
			}
			set{
				updatedHistory = value;
			}
		}

		/// <summary>
		/// Determine whether HistoryChangeEvent has a valid updatedHistory property.
		/// </summary>
		public bool UpdatedHistoryExists(){

			return (updatedHistory != null);
		}

	}//end HistoryChangeEvent

}//end namespace CallbackData