///////////////////////////////////////////////////////////
//  AISCategorizationData.cs
//  Implementation of the Class AISCategorizationData
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:54
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.CategorizationData;
namespace Org.OMG.TACSIT.DataPayload.CategorizationData {
	/// <summary>
	/// The data needed for displaying the AIS symbol set.
	/// </summary>
	public class AISCategorizationData : CategorizationData {

		private char cargoCategory;
		private String shipCategory;
		private String navigationalStatus;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public AISCategorizationData(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public AISCategorizationData(char the_cargoCategory, String the_shipCategory, String the_navigationalStatus){
			cargoCategory = the_cargoCategory;
			shipCategory = the_shipCategory;
			navigationalStatus = the_navigationalStatus;
		}

		/// <summary>
		/// Constructor with parameters for each mandatory property
		/// </summary>
		public AISCategorizationData(String the_shipCategory, String the_navigationalStatus){
			shipCategory = the_shipCategory;
			navigationalStatus = the_navigationalStatus;
		}

		~AISCategorizationData(){

		}

		/// <summary>
		/// The IMO categorisation of the cargo carried as identified on AIS
		/// </summary>
		public char CargoCategory{
			get{
				return cargoCategory;
			}
			set{
				cargoCategory = value;
			}
		}

		/// <summary>
		/// The type of ship.
		/// </summary>
		public string ShipCategory{
			get{
				return shipCategory;
			}
			set{
				shipCategory = value;
			}
		}

		/// <summary>
		/// Description of current navigational status and readiness
		/// </summary>
		public string NavigationalStatus{
			get{
				return navigationalStatus;
			}
			set{
				navigationalStatus = value;
			}
		}

	}//end AISCategorizationData

}//end namespace CategorizationData