///////////////////////////////////////////////////////////
//  STANAG5516CategorizationData.cs
//  Implementation of the Class STANAG5516CategorizationData
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:58
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.CategorizationData;
namespace Org.OMG.TACSIT.DataPayload.CategorizationData {
	/// <summary>
	/// This is a base class to support the display of entities based on the STANAG
	/// 5516 data model. This class contains attributes that relate to display
	/// filtering for any entities that have no symbol
	///        Note that this STANAG does not define symbology. The purpose of this
	/// class is to support custom symbology based on 5516 data model.
	/// </summary>
	public abstract class STANAG5516CategorizationData : MilitaryCategorizationData {

		private Org.OMG.TACSIT.DataPayload.Util.Environment environment;
		private Org.OMG.TACSIT.DataPayload.Util.Identity identity;
		private bool isForceTell;
		private bool isInExercise;
		private bool isSimulation;
		private Org.OMG.TACSIT.DataPayload.Util.TrackPhase trackState;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public STANAG5516CategorizationData(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public STANAG5516CategorizationData(Org.OMG.TACSIT.DataPayload.Util.Environment the_environment, Org.OMG.TACSIT.DataPayload.Util.Identity the_identity, bool the_isForceTell, bool the_isInExercise, bool the_isSimulation, Org.OMG.TACSIT.DataPayload.Util.TrackPhase the_trackState){
			environment = the_environment;
			identity = the_identity;
			isForceTell = the_isForceTell;
			isInExercise = the_isInExercise;
			isSimulation = the_isSimulation;
			trackState = the_trackState;
		}

		/// <summary>
		/// Constructor with parameters for each mandatory property
		/// </summary>
		public STANAG5516CategorizationData(Org.OMG.TACSIT.DataPayload.Util.Environment the_environment, bool the_isForceTell, bool the_isInExercise, bool the_isSimulation){
			environment = the_environment;
			isForceTell = the_isForceTell;
			isInExercise = the_isInExercise;
			isSimulation = the_isSimulation;
		}

		~STANAG5516CategorizationData(){

		}

		/// <summary>
		/// The environment that the Entity is in or to which it applies
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Environment Environment{
			get{
				return environment;
			}
			set{
				environment = value;
			}
		}

		/// <summary>
		/// The standard identity of the (track-like) entity
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Identity Identity{
			get{
				return identity;
			}
			set{
				identity = value;
			}
		}

		/// <summary>
		/// The ForceTell indicator is set
		/// </summary>
		public bool IsForceTell{
			get{
				return isForceTell;
			}
			set{
				isForceTell = value;
			}
		}

		/// <summary>
		/// The Entity has an Exercise indicator and so is part of an exercise.
		/// </summary>
		public bool IsInExercise{
			get{
				return isInExercise;
			}
			set{
				isInExercise = value;
			}
		}

		/// <summary>
		/// The Simulation indicator is set - e.g. the entity is for operator training
		/// purposes.
		/// </summary>
		public bool IsSimulation{
			get{
				return isSimulation;
			}
			set{
				isSimulation = value;
			}
		}

		/// <summary>
		/// If a track-like entity the state or phase of its lifecycle. Indicates whether
		/// tracking is active
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.TrackPhase TrackState{
			get{
				return trackState;
			}
			set{
				trackState = value;
			}
		}

	}//end STANAG5516CategorizationData

}//end namespace CategorizationData