///////////////////////////////////////////////////////////
//  Arcband.cs
//  Implementation of the Class Arcband
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:07
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// An entity represented as an area between two concentric circles and two radials
	/// of those circles. The arcband is defined by the two radii of the circles and
	/// the two angles of the radials moving from startangle to endangle in a clockwise
	/// direction.
	/// </summary>
	public class Arcband : ShapedEntity {

		private Org.OMG.TACSIT.DataPayload.Util.Distance minRadius;
		private Org.OMG.TACSIT.DataPayload.Util.Distance maxRadius;
		private Org.OMG.TACSIT.DataPayload.Util.Angle startAngle;
		private Org.OMG.TACSIT.DataPayload.Util.Angle endAngle;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate center;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public Arcband(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public Arcband(Org.OMG.TACSIT.DataPayload.Util.Distance the_minRadius, Org.OMG.TACSIT.DataPayload.Util.Distance the_maxRadius, Org.OMG.TACSIT.DataPayload.Util.Angle the_startAngle, Org.OMG.TACSIT.DataPayload.Util.Angle the_endAngle, Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate the_center){
			minRadius = the_minRadius;
			maxRadius = the_maxRadius;
			startAngle = the_startAngle;
			endAngle = the_endAngle;
			center = the_center;
		}

		~Arcband(){

		}

		/// <summary>
		/// The radius of the smaller circle. This number should be positive
		///          The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance MinRadius{
			get{
				return minRadius;
			}
			set{
				minRadius = value;
			}
		}

		/// <summary>
		/// The radius of the smaller circle. This number should be positive
		///          The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance MaxRadius{
			get{
				return maxRadius;
			}
			set{
				maxRadius = value;
			}
		}

		/// <summary>
		/// The start angle of the arc along an ellipse prior to rotation.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle StartAngle{
			get{
				return startAngle;
			}
			set{
				startAngle = value;
			}
		}

		/// <summary>
		/// The end angle of the arc along an ellipse prior to rotation.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle EndAngle{
			get{
				return endAngle;
			}
			set{
				endAngle = value;
			}
		}

		/// <summary>
		/// The center of the arcband.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate Center{
			get{
				return center;
			}
			set{
				center = value;
			}
		}

	}//end Arcband

}//end namespace EntityPayload