///////////////////////////////////////////////////////////
//  Bearing.cs
//  Implementation of the Class Bearing
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:07
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// An entity that is know to exist somewhere along a line of azimuth from an
	/// origin (typically the location of a passive sensor), but there is no
	/// information regarding its range (distance from the origin). On a TACSIT a
	/// bearing should be represented as a line from the origin to the edge of the
	/// display.
	/// </summary>
	public class Bearing : ShapedEntity {

		private Org.OMG.TACSIT.DataPayload.Util.Angle azimuth;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate origin;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public Bearing(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public Bearing(Org.OMG.TACSIT.DataPayload.Util.Angle the_azimuth, Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate the_origin){
			azimuth = the_azimuth;
			origin = the_origin;
		}

		~Bearing(){

		}

		/// <summary>
		/// The angle of azimuth for the bearing
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle Azimuth{
			get{
				return azimuth;
			}
			set{
				azimuth = value;
			}
		}

		/// <summary>
		/// The origin of the bearing.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate Origin{
			get{
				return origin;
			}
			set{
				origin = value;
			}
		}

		/// <summary>
		/// Determine whether Bearing has a valid origin property.
		/// </summary>
		public bool OriginExists(){

			return (origin != null);
		}

	}//end Bearing

}//end namespace EntityPayload