///////////////////////////////////////////////////////////
//  CartesianPosition.cs
//  Implementation of the Class CartesianPosition
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:07
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// Coordinates in a Cartesian reference frame as described by a coordinate
	/// specification object (from [OARIS]).
	/// </summary>
	public class CartesianPosition : PositionCoordinate {

		private Org.OMG.TACSIT.DataPayload.Util.Distance x;
		private Org.OMG.TACSIT.DataPayload.Util.Distance y;
		private Org.OMG.TACSIT.DataPayload.Util.Distance z;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public CartesianPosition(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public CartesianPosition(Org.OMG.TACSIT.DataPayload.Util.Distance the_x, Org.OMG.TACSIT.DataPayload.Util.Distance the_y, Org.OMG.TACSIT.DataPayload.Util.Distance the_z){
			x = the_x;
			y = the_y;
			z = the_z;
		}

		~CartesianPosition(){

		}

		/// <summary>
		/// X position of the point.
		///          The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance X{
			get{
				return x;
			}
			set{
				x = value;
			}
		}

		/// <summary>
		/// Y position of the point.
		///          The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance Y{
			get{
				return y;
			}
			set{
				y = value;
			}
		}

		/// <summary>
		/// Altitude of the point.
		///          The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance Z{
			get{
				return z;
			}
			set{
				z = value;
			}
		}

	}//end CartesianPosition

}//end namespace EntityPayload