///////////////////////////////////////////////////////////
//  Ellipse.cs
//  Implementation of the Class Ellipse
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:08
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// An entity represented as an ellipse.
	/// </summary>
	public class Ellipse : ShapedEntity {

		private Org.OMG.TACSIT.DataPayload.Util.Distance nSSemiAxis;
		private Org.OMG.TACSIT.DataPayload.Util.Distance eWSemiAxis;
		private Org.OMG.TACSIT.DataPayload.Util.Angle rotation;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate center;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public Ellipse(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public Ellipse(Org.OMG.TACSIT.DataPayload.Util.Distance the_nSSemiAxis, Org.OMG.TACSIT.DataPayload.Util.Distance the_eWSemiAxis, Org.OMG.TACSIT.DataPayload.Util.Angle the_rotation, Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate the_center){
			nSSemiAxis = the_nSSemiAxis;
			eWSemiAxis = the_eWSemiAxis;
			rotation = the_rotation;
			center = the_center;
		}

		~Ellipse(){

		}

		/// <summary>
		/// The North-South (before rotation) semi-axis of the ellipse. This number should
		/// be positive. The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance NSSemiAxis{
			get{
				return nSSemiAxis;
			}
			set{
				nSSemiAxis = value;
			}
		}

		/// <summary>
		/// The East-West (before rotation) semi-axis of the ellipse. This number should be
		/// positive. The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance EWSemiAxis{
			get{
				return eWSemiAxis;
			}
			set{
				eWSemiAxis = value;
			}
		}

		/// <summary>
		/// Rotation in the counter-clockwise direction.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle Rotation{
			get{
				return rotation;
			}
			set{
				rotation = value;
			}
		}

		/// <summary>
		/// The coordinates of the center of the ellipse.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate Center{
			get{
				return center;
			}
			set{
				center = value;
			}
		}

	}//end Ellipse

}//end namespace EntityPayload