///////////////////////////////////////////////////////////
//  ExtendedData.cs
//  Implementation of the Class ExtendedData
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:08
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// This class allows for extended data for an entity. An extended data is defined
	/// by a schema/key/value triple, the schema being a group of keys (sort of
	/// namespace).
	///        Extended Data are typically used to holds business-specific data that
	/// may be drawn/written around a symbol.
	///        Annex A standardizes a first set of extended data keys.
	/// </summary>
	public class ExtendedData {

		private String key;
		private String _value;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public ExtendedData(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public ExtendedData(String the_key, String the__value){
			key = the_key;
			_value = the__value;
		}

		~ExtendedData(){

		}

		/// <summary>
		/// Key of the extended data to be taken in the schema.
		/// </summary>
		public string Key{
			get{
				return key;
			}
			set{
				key = value;
			}
		}

		/// <summary>
		/// Value matching the key.
		/// </summary>
		public string Value{
			get{
				return _value;
			}
			set{
				_value = value;
			}
		}

	}//end ExtendedData

}//end namespace EntityPayload