///////////////////////////////////////////////////////////
//  FreeShapedEntity.cs
//  Implementation of the Class FreeShapedEntity
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:08
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// An entity represented in a client specific format through the SVG (Scalable
	/// Vector Graphics) standard.
	///        It has an optional origin. If it contains an origin then the SVG
	/// coordinates are interpreted as Cartesian relative to that origin. If there is
	/// no origin then the coordinates are interpreted with respect to a related entity
	/// (from an Entity Relation) as Cartesian. If there is no related entity then the
	/// coordinates are interpreted as absolute latitudes (y) and longitudes (x).
	///        This class supports the display of geometry for entities for which the
	/// TACSIT has no pre-defined symbology standard.
	/// </summary>
	public class FreeShapedEntity : ShapedEntity {

		private String svgDefinition;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate origin;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public FreeShapedEntity(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public FreeShapedEntity(String the_svgDefinition, Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate the_origin){
			svgDefinition = the_svgDefinition;
			origin = the_origin;
		}

		~FreeShapedEntity(){

		}

		/// <summary>
		/// An SVG xml file defining the appearance of the free shaped entity.
		/// </summary>
		public string SvgDefinition{
			get{
				return svgDefinition;
			}
			set{
				svgDefinition = value;
			}
		}

		/// <summary>
		/// The origin by which to interpret the coordinates within the SVG free shape
		/// definition.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate Origin{
			get{
				return origin;
			}
			set{
				origin = value;
			}
		}

		/// <summary>
		/// Determine whether FreeShapedEntity has a valid origin property.
		/// </summary>
		public bool OriginExists(){

			return (origin != null);
		}

	}//end FreeShapedEntity

}//end namespace EntityPayload