///////////////////////////////////////////////////////////
//  Multipoint.cs
//  Implementation of the Class Multipoint
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:08
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// A multipoint is a list of points without the semantics of a polyline (each
	/// point must be linked with a line) or a polygon (each point must be linked with
	/// a line and the figure is closed). The semantics is given by the associated
	/// CategorizationData. As examples, 2525 and APP6 series make a clear difference
	/// between multipoint and line.
	///        The rotation says that once the figure is drawn according to the
	/// CategorizationData, it must be rotated.
	/// </summary>
	public class Multipoint : ShapedEntity {

		private Org.OMG.TACSIT.DataPayload.Util.Angle rotation;
		private IList<Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate> points;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public Multipoint(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public Multipoint(Org.OMG.TACSIT.DataPayload.Util.Angle the_rotation, IList<Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate> the_points){
			rotation = the_rotation;
			points = the_points;
		}

		/// <summary>
		/// Constructor with parameters for each mandatory property
		/// </summary>
		public Multipoint(Org.OMG.TACSIT.DataPayload.Util.Angle the_rotation){
			rotation = the_rotation;
		}

		~Multipoint(){

		}

		/// <summary>
		/// Rotation in the counter-clockwise direction.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle Rotation{
			get{
				return rotation;
			}
			set{
				rotation = value;
			}
		}

		/// <summary>
		/// The coordinates of the mulitpoints
		/// </summary>
		public IList<Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate> Points{
			get{
				return points;
			}
			set{
				points = value;
			}
		}

	}//end Multipoint

}//end namespace EntityPayload