///////////////////////////////////////////////////////////
//  Orbit.cs
//  Implementation of the Class Orbit
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:08
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// An entity represented as an orbit path.
	///        The intended result the shape formed by linking together two half
	/// circles with two lines (a.k.a. an athletics track by the sportsmen among us).
	/// The first circle is centered on point one and the second circle is centered on
	/// point two. Both of them has the same radius given by the width attribute.
	/// </summary>
	public class Orbit : ShapedEntity {

		private Org.OMG.TACSIT.DataPayload.Util.Distance width;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate pointTwo;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate pointOne;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public Orbit(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public Orbit(Org.OMG.TACSIT.DataPayload.Util.Distance the_width, Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate the_pointTwo, Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate the_pointOne){
			width = the_width;
			pointTwo = the_pointTwo;
			pointOne = the_pointOne;
		}

		~Orbit(){

		}

		/// <summary>
		/// Width of the orbit. Width must be greater than zero.
		///          The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance Width{
			get{
				return width;
			}
			set{
				width = value;
			}
		}

		/// <summary>
		/// Second of the 2 points of the supporting corridor defining the sides of the
		/// orbit. The orbit is centered on the line across these 2 points.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate PointTwo{
			get{
				return pointTwo;
			}
			set{
				pointTwo = value;
			}
		}

		/// <summary>
		/// First of the 2 points of the supporting corridor defining the sides of the
		/// orbit. The orbit is centered on the line across these 2 points.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate PointOne{
			get{
				return pointOne;
			}
			set{
				pointOne = value;
			}
		}

	}//end Orbit

}//end namespace EntityPayload