///////////////////////////////////////////////////////////
//  PolarPosition.cs
//  Implementation of the Class PolarPosition
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:08
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// Coordinates in a polar reference frame as a described by a coordinate
	/// specification object (from [OARIS]).
	/// </summary>
	public class PolarPosition : PositionCoordinate {

		private Org.OMG.TACSIT.DataPayload.Util.Angle azimuth;
		private Org.OMG.TACSIT.DataPayload.Util.Angle elevation;
		private Org.OMG.TACSIT.DataPayload.Util.Distance range;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public PolarPosition(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public PolarPosition(Org.OMG.TACSIT.DataPayload.Util.Angle the_azimuth, Org.OMG.TACSIT.DataPayload.Util.Angle the_elevation, Org.OMG.TACSIT.DataPayload.Util.Distance the_range){
			azimuth = the_azimuth;
			elevation = the_elevation;
			range = the_range;
		}

		~PolarPosition(){

		}

		/// <summary>
		/// Azimuth of the point.
		///          The Angle unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle Azimuth{
			get{
				return azimuth;
			}
			set{
				azimuth = value;
			}
		}

		/// <summary>
		/// Elevation of the point.
		///          The Angle unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle Elevation{
			get{
				return elevation;
			}
			set{
				elevation = value;
			}
		}

		/// <summary>
		/// Distance of the point from the center.
		///          The Distance unit as well as the projection are set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance Range{
			get{
				return range;
			}
			set{
				range = value;
			}
		}

	}//end PolarPosition

}//end namespace EntityPayload