///////////////////////////////////////////////////////////
//  Text.cs
//  Implementation of the Class Text
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:09
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// An entity represented as a text.
	///        The 'point' attribute gives the left-lower starting position for left-to-
	/// right top-to-bottom languages, the right-lower starting position for right-to-
	/// left top-to-bottom languages, the left-upper starting position for top-to-
	/// bottom left-to-right languages and the right-upper starting position for top-to-
	/// bottom right-to-left languages.
	///        This attribute is implementation dependent for the other languages.
	/// </summary>
	public class Text : ShapedEntity {

		private String content;
		private Org.OMG.TACSIT.DataPayload.Util.Angle rotation;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate point;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public Text(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public Text(String the_content, Org.OMG.TACSIT.DataPayload.Util.Angle the_rotation, Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate the_point){
			content = the_content;
			rotation = the_rotation;
			point = the_point;
		}

		~Text(){

		}

		/// <summary>
		/// The text to be displayed.
		/// </summary>
		public string Content{
			get{
				return content;
			}
			set{
				content = value;
			}
		}

		/// <summary>
		/// Rotation in the counter-clockwise direction.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle Rotation{
			get{
				return rotation;
			}
			set{
				rotation = value;
			}
		}

		/// <summary>
		/// Position of the text (see description).
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate Point{
			get{
				return point;
			}
			set{
				point = value;
			}
		}

	}//end Text

}//end namespace EntityPayload