///////////////////////////////////////////////////////////
//  CoordinateUnits.cs
//  Implementation of the Class CoordinateUnits
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:55
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
namespace Org.OMG.TACSIT.DataPayload.GroupPayload {
	/// <summary>
	/// This class gathers the metadata that are specific to units: unit of distance,
	/// unit of angle and so forth.
	/// </summary>
	public class CoordinateUnits {

		private Org.OMG.TACSIT.DataPayload.Util.CoordinateOrientation? coordOrientation;
		private Org.OMG.TACSIT.DataPayload.Util.SpeedUnit? speedUnit;
		private Org.OMG.TACSIT.DataPayload.Util.CoordinateOrigin? coordOrigin;
		private Org.OMG.TACSIT.DataPayload.Util.DistanceUnit? distanceUnit;
		private Org.OMG.TACSIT.DataPayload.Util.CoordinateKind? coordKind;
		private Org.OMG.TACSIT.DataPayload.Util.Projection projection;
		private Org.OMG.TACSIT.DataPayload.Util.AngleUnit? angleUnit;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public CoordinateUnits(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public CoordinateUnits(Org.OMG.TACSIT.DataPayload.Util.CoordinateOrientation? the_coordOrientation, Org.OMG.TACSIT.DataPayload.Util.SpeedUnit? the_speedUnit, Org.OMG.TACSIT.DataPayload.Util.CoordinateOrigin? the_coordOrigin, Org.OMG.TACSIT.DataPayload.Util.DistanceUnit? the_distanceUnit, Org.OMG.TACSIT.DataPayload.Util.CoordinateKind? the_coordKind, Org.OMG.TACSIT.DataPayload.Util.Projection the_projection, Org.OMG.TACSIT.DataPayload.Util.AngleUnit? the_angleUnit){
			coordOrientation = the_coordOrientation;
			speedUnit = the_speedUnit;
			coordOrigin = the_coordOrigin;
			distanceUnit = the_distanceUnit;
			coordKind = the_coordKind;
			projection = the_projection;
			angleUnit = the_angleUnit;
		}

		~CoordinateUnits(){

		}

		/// <summary>
		/// The coordinate orientation used by the group. Default depend upon the
		/// coordinate kind.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.CoordinateOrientation? CoordOrientation{
			get{
				return coordOrientation;
			}
			set{
				coordOrientation = value;
			}
		}

		/// <summary>
		/// The speed Unit used by the group. SI is the default.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.SpeedUnit? SpeedUnit{
			get{
				return speedUnit;
			}
			set{
				speedUnit = value;
			}
		}

		/// <summary>
		/// The coordinate Origin used by the group. ABSOLUTE_REFERENCE_POINT is the
		/// default.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.CoordinateOrigin? CoordOrigin{
			get{
				return coordOrigin;
			}
			set{
				coordOrigin = value;
			}
		}

		/// <summary>
		/// The distance unit used by the group. SI is the default.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.DistanceUnit? DistanceUnit{
			get{
				return distanceUnit;
			}
			set{
				distanceUnit = value;
			}
		}

		/// <summary>
		/// The coordinate kind unit used by the group. GEODETIC is the default.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.CoordinateKind? CoordKind{
			get{
				return coordKind;
			}
			set{
				coordKind = value;
			}
		}

		/// <summary>
		/// The Projection used by the group. WGS84 is the default.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Projection Projection{
			get{
				return projection;
			}
			set{
				projection = value;
			}
		}

		/// <summary>
		/// Determine whether CoordinateUnits has a valid projection property.
		/// </summary>
		public bool ProjectionExists(){

			return (projection != null);
		}

		/// <summary>
		/// The angle unit used by the group. RAD is the default.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.AngleUnit? AngleUnit{
			get{
				return angleUnit;
			}
			set{
				angleUnit = value;
			}
		}

	}//end CoordinateUnits

}//end namespace GroupPayload