///////////////////////////////////////////////////////////
//  EntityRelationship.cs
//  Implementation of the Class EntityRelationship
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:56
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.GroupPayload {
	/// <summary>
	/// An item of relationship from an entity to another one. This item is moreover
	/// specified by a category and lives within a time span.
	/// </summary>
	public class EntityRelationship {

		private String category;
		private TimeSpan timeSpan;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef from;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef to;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public EntityRelationship(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public EntityRelationship(String the_category, TimeSpan the_timeSpan, Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef the_from, Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef the_to){
			category = the_category;
			timeSpan = the_timeSpan;
			from = the_from;
			to = the_to;
		}

		~EntityRelationship(){

		}

		/// <summary>
		/// Category of the relationship. This is a String whose content is to be specified
		/// by the implementation.
		/// </summary>
		public string Category{
			get{
				return category;
			}
			set{
				category = value;
			}
		}

		/// <summary>
		/// A show/hide period.
		/// </summary>
		public TimeSpan TimeSpan{
			get{
				return timeSpan;
			}
			set{
				timeSpan = value;
			}
		}

		/// <summary>
		/// The 'from' side of a relationship.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef From{
			get{
				return from;
			}
			set{
				from = value;
			}
		}

		/// <summary>
		/// The 'to' side of a relationship.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef To{
			get{
				return to;
			}
			set{
				to = value;
			}
		}

	}//end EntityRelationship

}//end namespace GroupPayload